/// <reference path="../../tsd.d.ts" />
import { OnInit, DefaultValueAccessor, ElementRef, NgModel, Renderer } from 'angular2/angular2';
export declare const timepickerConfig: {
    hourStep: number;
    minuteStep: number;
    showMeridian: boolean;
    meridians: any;
    readonlyInput: boolean;
    mousewheel: boolean;
    arrowkeys: boolean;
    showSpinners: boolean;
    min: any;
    max: any;
};
export declare class Timepicker extends DefaultValueAccessor implements OnInit {
    private _selected;
    private hourStep;
    private minuteStep;
    private _showMeridian;
    private meridian;
    private meridians;
    private readonlyInput;
    private mousewheel;
    private arrowkeys;
    private showSpinners;
    private min;
    private max;
    private hours;
    private minutes;
    private selected;
    private invalidHours;
    private invalidMinutes;
    private showMeridian;
    constructor(cd: NgModel, renderer: Renderer, elementRef: ElementRef);
    onInit(): void;
    writeValue(v: any): void;
    private refresh(type?);
    private updateTemplate(keyboardChange?);
    private getHoursFromTemplate();
    private getMinutesFromTemplate();
    private pad(value);
    private setupMousewheelEvents();
    private setupArrowkeyEvents();
    private setupInputEvents();
    private updateHours();
    private hoursOnBlur(event);
    private updateMinutes();
    private minutesOnBlur(event);
    private noIncrementHours();
    private noDecrementHours();
    private noIncrementMinutes();
    private noDecrementMinutes();
    private addMinutesToSelected(minutes);
    noToggleMeridian(): boolean;
    private incrementHours();
    private decrementHours();
    private incrementMinutes();
    private decrementMinutes();
    private toggleMeridian();
}
